package astro.virgo;

import java.util.ArrayList;
import java.util.EnumSet;
import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.view.View.OnFocusChangeListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import astro.virgo.models.ExposureModel;
import astro.virgo.models.ExposureModel.enumCamere;
import astro.virgo.models.ExposureModel.enumConstellation;
import astro.virgo.models.ExposureModel.enumStelle;
import astro.virgo.models.SpinAdapter;

public class MainActivity extends Activity {
	
	private ExposureModel model;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		/////////////////////////////////////////////////////////
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		this.model = new ExposureModel();
		
		/////////////////////////////////////////////////////////
		final Spinner s1 = (Spinner) findViewById(R.id.spinner1);
		List<enumStelle> stelle = new ArrayList<enumStelle>(EnumSet.allOf(enumStelle.class));
		final SpinAdapter<enumStelle> userAdapter = new SpinAdapter<enumStelle>(this, R.layout.spinner, stelle);
		s1.setAdapter(userAdapter);
		// http://stackoverflow.com/questions/1337424/android-spinner-get-the-selected-item-change-event
		s1.setOnItemSelectedListener(new OnItemSelectedListener() {
		    @Override
		    public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
		    	enumStelle e = (enumStelle) userAdapter.getItem(position);
		    	MainActivity.this.model.setStelle(e);
		    	MainActivity.this.calcola(null);
		    }
		    @Override
		    public void onNothingSelected(AdapterView<?> parentView) {
		    	enumStelle e = enumStelle.STELLE_PUNTIFORMI;
		    	MainActivity.this.model.setStelle(e);
		    	//set the default according to value
		    	int spinnerPosition = userAdapter.getPosition(e);
		    	s1.setSelection(spinnerPosition);
		    	MainActivity.this.calcola(null);
		    }
		});
		
		/////////////////////////////////////////////////////////
		final Spinner s2 = (Spinner) findViewById(R.id.spinner2);
		List<enumConstellation> costell = new ArrayList<enumConstellation>(EnumSet.allOf(enumConstellation.class));
		final SpinAdapter<enumConstellation> userAdapter2 = new SpinAdapter<enumConstellation>(this, R.layout.spinner, costell);
		s2.setAdapter(userAdapter2);
		// http://stackoverflow.com/questions/1337424/android-spinner-get-the-selected-item-change-event
		s2.setOnItemSelectedListener(new OnItemSelectedListener() {
		    @Override
		    public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
		        enumConstellation e = (enumConstellation) userAdapter2.getItem(position);
		    	MainActivity.this.model.setCostellazione(e);
		    	MainActivity.this.calcola(null);
		    }
		    @Override
		    public void onNothingSelected(AdapterView<?> parentView) {
		    	enumConstellation e = enumConstellation.NULL;
		    	MainActivity.this.model.setCostellazione(e);
		    	//set the default according to value
		    	int spinnerPosition = userAdapter2.getPosition(e);
		    	s2.setSelection(spinnerPosition);
		    	MainActivity.this.calcola(null);
		    }
		});

		/////////////////////////////////////////////////////////
		final Spinner s3 = (Spinner) findViewById(R.id.spinner3);
		List<enumCamere> camere = new ArrayList<enumCamere>(EnumSet.allOf(enumCamere.class));
		final SpinAdapter<enumCamere> userAdapter3 = new SpinAdapter<enumCamere>(this, R.layout.spinner, camere);
		s3.setAdapter(userAdapter3);
		// http://stackoverflow.com/questions/1337424/android-spinner-get-the-selected-item-change-event
		s3.setOnItemSelectedListener(new OnItemSelectedListener() {
		    @Override
		    public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
		    	enumCamere e = (enumCamere) userAdapter3.getItem(position);
		    	MainActivity.this.model.setCamera(e);
		    	MainActivity.this.calcola(null);
		    }
		    @Override
		    public void onNothingSelected(AdapterView<?> parentView) {
		    	enumCamere e = enumCamere.NULL;
		    	MainActivity.this.model.setCamera(e);
		    	//set the default according to value
		    	int spinnerPosition = userAdapter3.getPosition(e);
		    	s3.setSelection(spinnerPosition);
		    	MainActivity.this.calcola(null);
		    }
		});
		
		/////////////////////////////////////////////////////////
		final EditText t1 = (EditText) findViewById(R.id.editText1);
		// http://stackoverflow.com/questions/4310525/android-on-edittext-changed-listener
		t1.addTextChangedListener(new TextWatcher(){
	        public void afterTextChanged(Editable s) {
	        	MainActivity.this.model.setFocale(s.toString());
	        }
	        public void beforeTextChanged(CharSequence s, int start, int count, int after){}
	        public void onTextChanged(CharSequence s, int start, int before, int count){
	        	MainActivity.this.model.setFocale(s.toString());
//	        	t1.selectAll();
	        }
	    }); 
//		t1.setOnFocusChangeListener(new OnFocusChangeListener() {
//	        @Override
//	        public void onFocusChange(View v, boolean hasFocus) {
//	            if (!hasFocus) {
//	            	
//	            }
//	        }
//		});
		
		/////////////////////////////////////////////////////////
		TextView ris = (TextView) findViewById(R.id.textView1);
		ris.setText("0.0");
		
	}

//	@Override
//	public boolean onCreateOptionsMenu(Menu menu) {
//		// Inflate the menu; this adds items to the action bar if it is present.
//		getMenuInflater().inflate(R.menu.main, menu);
//		return true;
//	}
	
	
	public void calcola(View v) {
		TextView ris = (TextView) findViewById(R.id.textView1);
		System.out.println(model.exposure());
		ris.setText( model.exposure()+"" );
	}
	
	public void reset(View v) {
		Spinner s;
		TextView t;
		
		s = (Spinner) findViewById(R.id.spinner1);
		s.setSelection(0);
		
		s = (Spinner) findViewById(R.id.spinner2);
		s.setSelection(0);
		
		s = (Spinner) findViewById(R.id.spinner3);
		s.setSelection(0);
		
		t = (TextView) findViewById(R.id.textView1);
		t.setText("0.0");
		
		t = (EditText) findViewById(R.id.editText1);
		t.setText("0.0");
		
	}

}
