/**
 * 
 */
package astro.virgo.models;

/**
 * @author fabio
 *
 */
public class ExposureModel {
	
	private enumStelle k2 = enumStelle.STELLE_PUNTIFORMI;
	
    private enumConstellation k1 = enumConstellation.NULL;
    
    private enumCamere pixeldimension = enumCamere.NULL;
    
    float exposure;
    
    float focal;
    
//    String camera;
//    String constellation;
//    String starquality;
    
    public void setStelle(enumStelle value) {
    	this.k2 = value;
    }
    
    public void setCostellazione(enumConstellation value) {
    	this.k1 = value;
    }
    
    public void setCamera(enumCamere value) {
    	this.pixeldimension = value;
    }
    
    public void setFocale(String value) {
    	String focalstring;
    	focalstring = value;
    	focalstring = focalstring.replaceAll(",",".");
    	try {
    		this.focal = Float.parseFloat(focalstring);
    	} catch(Exception e) {
    		this.focal = 0.0f;
    	}
    }
    
    public boolean check() {
    	if(this.focal == 0.0f || pixeldimension == enumCamere.NULL || k1 == enumConstellation.NULL) {
//    		jTextField3.setText("Inserire Valori Corretti");}
    		return false;
    	} else {
    		return true;
    	}
    }
    
    public void calcExposure() {
    	if(check()) {
    		this.exposure = this.k1.value() * this.k2.value() * this.pixeldimension.value() / this.focal;
    	} else {
    		this.exposure = 0.0f;
    	}
    }
    
    public float exposure() {
    	calcExposure();
    	return this.exposure;
    }
    
    public enum enumStelle {
    	
    	STELLE_PUNTIFORMI(1.5f,"stelle puntiformi"),
    	STELLE_OBLUNGHE(4.0f,"stelle oblunghe"),
    	STELLE_LEGGERMENTE_MOSSE(6.0f,"stelle leggermente mosse");
    	
    	private float value = 1.5f;
    	private String label = "stelle puntiformi";
    	
    	enumStelle(float value, String label) {
//            System.out.println("Name: " + this.name() + " initialized.");
            this.value = value;
            this.label = label;
        }
    	
    	public float value() {
    		return this.value;
    	}
    	
    	public String label() {
    		return this.label;
    	}
    	
    }
    
    public enum enumConstellation {
    	
    	NULL(0.0f,"Selezionare Costellazione"),
    	Acquario(16.72f,"Acquario"),
    	Altare(21.87f,"Altare"),
    	Andromeda(18.85f,"Andromeda"),
    	Aquila(14.38f,"Aquila"),
    	Ariete(16.52f,"Ariete"),
    	Auriga(19.54f,"Auriga"),
    	Balena(14.82f,"Balena"),
    	Bilancia(15.81f,"Bilancia"),
    	Boote(17.95f,"Boote"),
    	Bulino(18.92f,"Bulino"),
    	Bussola(17.41f,"Bussola"),
    	Camaleonte(25.90f,"Camaleonte"),
    	Cancro(16.39f,"Cancro"),
    	CaneMaggiore(16.70f,"Cane Maggiore"),
    	CaneMinore(14.73f,"Cane Minore"),
    	CanidaCaccia(19.25f,"Cani da Caccia"),
    	Carena(23.00f,"Carena"),
    	Capricorno(16.16f,"Capricorno"),
    	Cassiopea(22.82f,"Cassiopea"),
    	Cavallino(14.89f,"Cavallino"),
    	Cefeo(24.38f,"Cefeo"),
    	Centauro(20.37f,"Centauro"),
    	ChiomadiBerenice(16.86f,"Chioma di Berenice"),
    	Cigno(19.93f,"Cigno"),
    	Colomba(18.51f,"Colomba"),
    	Compasso(22.97f,"Compasso"),
    	CoronaAustrale(19.41f,"Corona Australe"),
    	CoronaBoreale(18.15f,"Corona Boreale"),
    	Corvo(16.22f,"Corvo"),
    	Cratere(15.90f,"Cratere"),
    	CrocedelSud(22.48f,"Croce del Sud"),
    	Delfino(15.36f,"Delfino"),
    	Dorado(22.34f,"Dorado"),
    	Dragone(23.66f,"Dragone"),
    	Ercole(17.43f,"Ercole"),
    	Eridano(17.60f,"Eridano"),
    	Fenice(20.56f,"Fenice"),
    	Fornace(18.01f,"Fornace"),
    	Freccia(16.27f,"Freccia"),
    	Gemelli(16.76f,"Gemelli"),
    	Giraffa(24.09f,"Giraffa"),
    	Gru(20.21f,"Gru"),
    	Idra(15.72f,"Idra"),
    	IdraMaschio(24.19f,"Idra Maschio"),
    	Indiano(22.39f,"Indiano"),
    	Leone(15.55f,"Leone"),
    	LeoneMinore(18.08f,"Leone Minore"),
    	Lepre(16.30f,"Lepre"),
    	Lince(20.39f,"Lince"),
    	Lira(18.74f,"Lira"),
    	Lucertola(20.16f,"Lucertola"),
    	Lupo(19.65f,"Lupo"),
    	MacchinaPneumatica(18.13f,"Macchina Pneumatica"),
    	Mensa(25.58f,"Mensa"),
    	Microscopio(18.68f,"Microscopio"),
    	Mosca(24.23f,"Mosca"),
    	Ofiuco(14.91f,"Ofiuco"),
    	Orione(14.68f,"Orione"),
    	Orologio(21.33f,"Orologio"),
    	OrsaMaggiore(20.91f,"Orsa Maggiore"),
    	OrsaMinore(25.61f,"Orsa Minore"),
    	Ottante(26.46f,"Ottante"),
    	Pavone(23.45f,"Pavone"),
    	Pegaso(16.78f,"Pegaso"),
    	Perseo(20.00f,"Perseo"),
    	PesceAustrale(17.87f,"Pesce Australe"),
    	PesceVolante(24.16f,"Pesce Volante"),
    	Pesci(15.61f,"Pesci"),
    	Pittore(21.35f,"Pittore"),
    	Poppa(17.94f,"Poppa"),
    	Regolo(21.01f,"Regolo"),
    	Reticolo(22.44f,"Reticolo"),
    	Sagittario(17.56f,"Sagittario"),
    	Scorpione(17.36f,"Scorpione"),
    	Scudo(16.25f,"Scudo"),
    	Scultore(18.07f,"Scultore"),
    	Serpente(14.70f,"Serpente"),
    	Sestante(14.29f,"Sestante"),
    	Telescopio(20.96f,"Telescopio"),
    	Toro(15.76f,"Toro"),
    	Triangolo(17.99f,"Triangolo"),
    	TriangoloAustrale(23.38f,"Triangolo Australe"),
    	Tucano(23.45f,"Tucano"),
    	UccellodelParadiso(25.17f,"Uccello del Paradiso"),
    	Unicorno(14.03f,"Unicorno"),
    	Vele(20.34f,"Vele"),
    	Vergine(14.47f,"Vergine"),
    	Volpetta(17.01f,"Volpetta");
    	
    	private float value = 0.0f;
    	private String label = "";
    	
    	enumConstellation(float value, String label) {
//            System.out.println("Name: " + this.name() + " initialized.");
            this.value = value;
            this.label = label;
        }
    	
    	public float value() {
    		return this.value;
    	}
    	
    	public String label() {
    		return this.label;
    	}
    	
    }

    public enum enumCamere {
    	
    	NULL(0.0f,"Selezionare Fotocamera Digitale"),
    	CanonEOS1000D(5.7f,"Canon EOS 1000D"),
    	CanonEOS1100D(5.2f,"Canon EOS 1100D"),
    	CanonEOS300D(7.4f,"Canon EOS 300D"),
    	CanonEOS350D(6.4f,"Canon EOS 350D"),
    	CanonEOS400D(5.7f,"Canon EOS 400D"),
    	CanonEOS450D(5.2f,"Canon EOS 450D"),
    	CanonEOS500D(4.7f,"Canon EOS 500D"),
    	CanonEOS550D(4.3f,"Canon EOS 550D"),
    	CanonEOS600D(4.3f,"Canon EOS 600D"),
    	CanonEOS650D(4.3f,"Canon EOS 650D"),
    	CanonEOS700D(4.3f,"Canon EOS 700D"),
    	CanonEOS100D(4.3f,"Canon EOS 100D"),
    	CanonEOSD30(10.2f,"Canon EOS 30D"),
    	CanonEOSD60(7.4f,"Canon EOS 30D"),
    	CanonEOS10D(7.4f,"Canon EOS 30D"),
    	CanonEOS20D(6.4f,"Canon EOS 30D"),
    	CanonEOS30D(6.4f,"Canon EOS 30D"),
    	CanonEOS40D(5.7f,"Canon EOS 40D"),
    	CanonEOS50D(4.7f,"Canon EOS 50D"),
    	CanonEOS60D(4.3f,"Canon EOS 60D"),
    	CanonEOS20Da(6.4f,"Canon EOS 20Da"),
    	CanonEOS60Da(4.3f,"Canon EOS 60Da"),
    	CanonEOS7D(4.3f,"Canon EOS 7D"),
    	CanonEOS6D(6.5f,"Canon EOS 6D"),
    	CanonEOS5D(8.1f,"Canon EOS 5D"),
    	CanonEOS5DMarkII(6.4f,"Canon EOS 5D Mark II"),
    	CanonEOS5DMarkIII(6.25f,"Canon EOS 5D Mark III"),
    	CanonEOS1D(10.8f,"Canon EOS 1D"),
    	CanonEOS1DMarkII(8.1f,"Canon EOS 1D Mark II"),
    	CanonEOS1DMarkIIN(8.2f,"Canon EOS 1D Mark II N"),
    	CanonEOS1DMarkIII(7.4f,"Canon EOS 1D Mark III"),
    	CanonEOS1DMarkIV(5.6f,"Canon EOS 1D Mark IV"),
    	CanonEOS1Ds(8.8f,"Canon EOS 1Ds"),
    	CanonEOS1DsMarkII(7.2f,"Canon EOS 1Ds Mark II"),
    	CanonEOS1DsMarkIII(6.4f,"Canon EOS 1Ds Mark III"),
    	CanonEOS1DX(6.9f,"Canon EOS 1D X"),
    	NikonD40(7.8f,"Nikon D40"),
    	NikonD3000(6.09f,"Nikon D3000"),
    	NikonD3100(5.0f,"Nikon D3100"),
    	NikonD3200(3.8f,"Nikon D3200"),
    	NikonD50(7.8f,"Nikon D50"),
    	NikonD40x(6.1f,"Nikon D40x"),
    	NikonD60(6.1f,"Nikon D60"),
    	NikonD5000(5.5f,"Nikon D5000"),
    	NikonD5100(4.8f,"Nikon D5100"),
    	NikonD5200(3.9f,"Nikon D5200"),
    	NikonD70(7.8f,"Nikon D70"),
    	NikonD70s(7.8f,"Nikon D70s"),
    	NikonD80(6.1f,"Nikon D80"),
    	NikonD90(5.5f,"Nikon D90"),
    	NikonD7000(4.8f,"Nikon D7000"),
    	NikonD7100(3.9f,"Nikon D7100"),
    	NikonD600(5.9f,"Nikon D600"),
    	NikonD100(7.8f,"Nikon D100"),
    	NikonD200(6.1f,"Nikon D200"),
    	NikonD300(5.5f,"Nikon D300"),
    	NikonD300s(5.5f,"Nikon D300s"),
    	NikonD700(8.5f,"Nikon D700"),
    	NikonD800(4.9f,"Nikon D800"),
    	NikonD800E(4.9f,"Nikon D800E"),
    	NikonD1H(11.9f,"Nikon D1H"),
    	NikonD2H(9.4f,"Nikon D2H"),
    	NikonD2Hs(9.4f,"Nikon D2Hs"),
    	NikonD3(8.4f,"Nikon D3"),
    	NikonD3s(8.4f,"Nikon D3s"),
    	NikonD4(7.3f,"Nikon D4"),
    	NikonD1(11.8f,"Nikon D1"),
    	NikonD1X(7.8f,"Nikon D1X"),
    	NikonD2X(5.5f,"Nikon D2X"),
    	NikonD2Xs(5.5f,"Nikon D2Xs"),
    	NikonD3X(5.9f,"Nikon D3X");
    	
    	private float value = 0.0f;
    	private String label = "";
    	
    	enumCamere(float value, String label) {
//            System.out.println("Name: " + this.name() + " initialized.");
            this.value = value;
            this.label = label;
        }
    	
    	public float value() {
    		return this.value;
    	}
    	
    	public String label() {
    		return this.label;
    	}
    	
    }
    
}
