package astro.virgo.models;

import java.util.List;

import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import astro.virgo.models.ExposureModel.enumConstellation;
import astro.virgo.models.ExposureModel.enumStelle;
import astro.virgo.models.ExposureModel.enumCamere;

public class SpinAdapter<T> extends ArrayAdapter<T> {
	private Context context;
	private List<T> values;
	
	public SpinAdapter(Context context, int textViewResourceId, List<T> values) {
	    super(context, textViewResourceId, values);
	    this.context = context;
	    this.values = values;
	}
	
	public int getCount() {
	    return values.size();
	}
	
	public T getItem(int position) {
	    return values.get(position);
	}
	
	public long getItemId(int position) {
	    return position;
	}
	
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
	    TextView label = new TextView(context);
	    //label.setTextColor(Color.BLACK);
	    label.setTextColor(Color.RED);
	    Object[] oa = values.toArray(new Object[values.size()]);
	    if( oa[position].getClass().equals(enumStelle.class) ) {
	    	label.setText( ((enumStelle)(oa[position])).label()+"" );
	    } else if( oa[position].getClass().equals(enumConstellation.class) ) {
	    	label.setText( ((enumConstellation)(oa[position])).label()+"" );
	    } else if( oa[position].getClass().equals(enumCamere.class) ) {
	    	label.setText( ((enumCamere)(oa[position])).label()+"" );
	    }
	    return label;
	}
	
	@Override
	public View getDropDownView(int position, View convertView, ViewGroup parent) {
	    TextView label = new TextView(context);
	    //label.setTextColor(Color.BLACK);
	    label.setTextSize(24.0f);
	    Object[] oa = values.toArray(new Object[values.size()]);
	    label.setTextColor(Color.RED);
	    if( oa[position].getClass().equals(enumStelle.class) ) {
	    	label.setText( ((enumStelle)(oa[position])).label()+"" );
	    } else if( oa[position].getClass().equals(enumConstellation.class) ) {
	    	label.setText( ((enumConstellation)(oa[position])).label()+"" );
	    } else if( oa[position].getClass().equals(enumCamere.class) ) {
	    	label.setText( ((enumCamere)(oa[position])).label()+"" );
	    }
	    
	    return label;
	}
}